//bmp.h

#ifndef _BMP_H_
#define _BMP_H_

#include "types.h"
#include "bmp_server.h"

//#define _version_h      "V 2.0"
#define _BMP_version_h		0x151230        //год:месяц:число

#pragma pack(1)



//В начале стоит заголовок файла (BITMAPFILEHEADER). Он описан следующим образом:
#pragma pack(1)
typedef struct tagBITMAPFILEHEADER {
    WORD	bfType;
    DWORD	bfSize;
    WORD	bfReserved1;
    WORD	bfReserved2;
    DWORD	bfOffBits;
} BITMAPFILEHEADER, *PBITMAPFILEHEADER;


//А дальше идет структура BITMAPINFOHEADER, которая объявлена так:
#pragma pack(1)
typedef struct tagBITMAPINFOHEADER {
    DWORD	biSize;
    U32		biWidth;
    U32		biHeight;
    WORD	biPlanes;
    WORD	biBitCount;
    DWORD	biCompression;
    DWORD	biSizeImage;
    LONG	biXPelsPerMeter;
    LONG	biYPelsPerMeter;
    DWORD	biClrUsed;
    DWORD	biClrImportant;
} BITMAPINFOHEADER, *PBITMAPINFOHEADER;

//позиция версии структуры
#define _bcSize          0x0E

typedef struct tagBITMAPINFOHEADERr {
    DWORD	biSize;
    U8		data[128];
} BITMAPINFOHEADERr, *PBITMAPINFOHEADERr;

#pragma pack(1)
typedef struct tagRGBQUAD {
    BYTE	rgbBlue;
    BYTE	rgbGreen;
    BYTE	rgbRed;
    BYTE	rgbReserved;
} RGBQUAD;

#pragma pack(1)
typedef struct _BMP_PAR {
    U32		step_x;
    U32		step_y;
} BMP_PAR;

#define _BMP_DUMP_SIZE_     0x200000
extern U8 BMP_DUMP[_BMP_DUMP_SIZE_];
#define _interval_redraw            500000
extern U8 BMP_REDRAW_WORK;      //поток перезаписи
extern U8 BMP_FILE;;


/*
***************************************
* функции статуса изображения         *
***************************************
*/
extern int BMP_FileAnalise(char *fname);

/*
*****************************************************
* функции прямого обращения к элементам изображению *
*****************************************************
*/
extern int BMP_SetPixel(FILE * file, LONG x, LONG y, U8 R, U8 G, U8 B);
extern int BMP_GetPixel(FILE * file, LONG x, LONG y, U8 * R, U8 * G, U8 * B);

/*
*****************************************************
* функции примитивов  (формирования фигур/элементов)*
*****************************************************
*/
//линия (отрезок) 
extern void BMP_Line(FILE * file, U32 x1, U32 y1, U32 x2, U32 y2, U8 R, U8 G, U8 B);
//окружность-круг
extern void BMP_Circle(FILE * file, U32 x, U32 y, U32 radius, U8 R, U8 G, U8 B);
extern void BMP_Circlefill(FILE * file, U32 x, U32 y, U32 radius, U8 R, U8 G, U8 B);
extern void BMP_Circlefill_fuzzy(FILE * file, U32 x, U32 y, U32 radius, BYTE R, BYTE G, BYTE B, int f);
//прямоугольник
extern void BMP_rect(FILE * file, U32 x1, U32 y1, U32 x2, U32 y2, BYTE R, BYTE G, BYTE B);
extern void BMP_rect_filled(FILE * file, U32 x1, U32 y1, U32 x2, U32 y2, BYTE R, BYTE G, BYTE B);
//треугольник
extern void BMP_triangle(FILE * file, U32 x1, U32  y1, U32 x2, U32 y2, U32 x3, U32 y3, BYTE R, BYTE G, BYTE B);


/*
****************************************************
* служебные функции                                *
****************************************************
*/
extern  void pthBMP_Redraw(void);


#endif
