//bmp_server.h

#ifndef _bmp_server_h_
#define _bmp_server_h_

#include <pthread.h>
#include "types.h"

#define _BMP_Server_Version_    "1.0"


//#pragma pack(1)

typedef struct _DAT_BMP_SERVER
{
    U8  work;
    U8  stoped;
    //
    int  serverfd;
    int  clientfd;
    FILE * ffile;
} DAT_BMP_SERVER;

typedef struct _DAT_BMP_CLIENT
{
    int             clientfd;
    pthread_t pthread; 
}DAT_BMP_CLIENT;

/***************************************
БИНАРНЫЙ  ФОРМАТ
****************************************/
#define _id_bin					0x00                            //идентификатор бинарного обращения
//адреса принятого массива
#define _id_in_bin_addr				0x00000000              //1-,байт - идентификатора бинарного обмена
#define _size_in_addr				0x00000001              //4 байта - размер принимаемого массива
#define _incmd_addr				0x00000005              //2 байта - команда

#define _incmd_filename				0x00000007              //начало имени файла  

//==== bsetpixel ===
#define _addr_setpixel_X1			0x00000007              //4 байта
#define _addr_setpixel_Y1			0x0000000B              //4 байта
#define _addr_setpixel_R			0x0000000F              //1 байт
#define _addr_setpixel_G			0x00000010              //1 байт
#define _addr_setpixel_B			0x00000011              //1 байт

//==== bline ====
#define _addr_line_X1				0x00000007              //4 байта
#define _addr_line_Y1				0x0000000B              //4 байта
#define _addr_line_X2				0x0000000F              //4 байта
#define _addr_line_Y2				0x00000013              //4 байта
#define _addr_line_R				0x00000017              //1 байт
#define _addr_line_G				0x00000018              //1 байт
#define _addr_line_B				0x00000019              //1 байт

//==== triangle ====
#define _addr_triangle_X1			0x00000007              //4 байта
#define _addr_triangle_Y1			0x0000000B              //4 байта
#define _addr_ltriangle_X2			0x0000000F              //4 байта
#define _addr_triangle_Y2			0x00000013              //4 байта
#define _addr_triangle_X3			0x00000017              //4 байта
#define _addr_triangle_Y3			0x0000001B              //4 байта
#define _addr_triangle_R			0x0000001F              //1 байт
#define _addr_triangle_G			0x00000020              //1 байт
#define _addr_triangle_B			0x00000021              //1 байт

//адреса передаваемого массива
#define _id_out_bin_addr			0x00000000              //1-,байт - идентификатора бинарного обмена
#define _size_out_addr				0x00000001              //4 байта - размер принимаемого массива 
#define _outcmd_addr				0x00000005              //2 байта - команда
#define _outcmd_stat_addr			0x00000007              //1 - байт - статус выполнения команды


//коды команд
#define _bmp_cmd_nop				0x0000                      //пустая команда

#define _bmp_cmd_openfile			0x0101                      //открыть файл для работы

#define _bmp_cmd_setpixel			0x0201                      //установка пикселя - нарисовать пиксель
#define _bmp_cmd_ssetpixel			18                      //размер пакета команды _bmp_cmd_setpixel

#define _bmp_cmd_line				0x0301                      //нарисовать линию
#define _bmp_cmd_sline				26                     //размер пакета команды _bmp_cmd_setpixel

#define _bmp_cmd_triangle			0x0401                      //нарисовать треугольник

#define _bmp_cmd_rect				0x0501                      //нарисовать прямоугольник

#define _bmp_cmd_circle				0x0601                     //нарисовать окружность
#define _bmp_cmd_circlefill			0x0602                     //нарисовать круг
#define _bmp_cmd_circlefill_fuzzy		0x0603                     //нарисовать круг

//коды статуса выполнения
#define _bmp_cmd_stat_ok                        0x00          //команда выполнена успешно
#define _bmp_cmd_stat_err                       0x81         //ошибка выполнения команды
#define _bmp_cmd_stat_notposible		0x82         //нет возможности выполнить команду (не открыт файл, ...)        
#define _bmp_cmd_stat_none			0xFF         //неизвесная команда






extern DAT_BMP_SERVER dat_bmp_server;

extern pthread_mutex_t mt;

extern int BMP_SERVER_Start(U32 port);
extern int BMP_SERVER_Stop(void);
extern void BMP_SERVER_Listen(void );
extern void BMP_CLIENT(DAT_BMP_CLIENT * clieent);


#endif
