//main.h

#ifndef _main_h_
#define _main_h_

#include "types.h"

#define __help__ "==========\r\n\  
\"help\" -- current help screen\r\n\
\"quit\" -- for exit\r\n\
\r\n\
SRING MODE:\r\n\
\"connect\" -- connect to bmp_server\r\n\
\"disconnect\" -- disconnect from bmp_server\r\n\
\r\n\
\"fileopen\" -- open file for work (not creating)\r\n\
\"fileclose\" -- close opened file\r\n\
\r\n\
\"setpixel\" -- dawing one pixel in opened file (command \"fileopen\") <X and Y - coordinats>, <R,G,B - color>\r\n\
\"line\" -- dawing line in opened file (command \"fileopen\") <X1,Y1 and X2,Y2 - coordinats>, <R,G,B - color>\r\n\
\"circle\" -- dawing circle in opened file (command \"fileopen\") <X1 and X2 - coordinats>, <RADIUS - radius of circle>, <R,G,B - color>\r\n\
\"circlefill\" -- dawing filled circle in opened file (command \"fileopen\") <X1 and X2 - coordinats>, <RADIUS - radius of circle>, <R,G,B - color>\r\n\
\"circlefill_fuzzy\" -- dawing filled circle fuzzy in opened file (command \"fileopen\") <X1 and X2 - coordinats>, <RADIUS - radius of circle>, <R,G,B - color>\r\n\
\"rect\" -- dawing rectangle in opened file (command \"fileopen\") <X1,Y1 and X2,Y2 - coordinats>, <R,G,B - color>\r\n\
\"rect_filled\" -- dawing rectangle filled in opened file (command \"fileopen\") <X1,Y1 and X2,Y2 - coordinats>, <R,G,B - color>\r\n\
\"triangle\" -- dawing triangle in opened file (command \"fileopen\") <X1,Y1 and X2,Y2 and X3,Y3 - coordinats>, <R,G,B - color>\r\n\
\r\n\
BINARY MODE:\r\n\
\"bconnect\" -- connect to bmp_server\r\n\
\"bdisconnect\" -- disconnect from bmp_server\r\n\
\r\n\
\"bfileopen\" -- open file for work (not creating)\r\n\
\"bfleclose\" -- close opened file\r\n\
\r\n\
\"bsetpixel\" -- dawing one pixel in opened file (command \"fileopen\") <X and Y - coordinats>, <R,G,B - color>\r\n\
\"bline\" -- dawing line in opened file (command \"fileopen\") <X1,Y1 and X2,Y2 - coordinats>, <R,G,B - color>\r\n\
\"bcircle\" -- dawing circle in opened file (command \"fileopen\") <X1 and X2 - coordinats>, <RADIUS - radius of circle>, <R,G,B - color>\r\n\
\"bcirclefill\" -- dawing filled circle in opened file (command \"fileopen\") <X1 and X2 - coordinats>, <RADIUS - radius of circle>, <R,G,B - color>\r\n\
\"bcirclefill_fuzzy\" -- dawing filled circle fuzzy in opened file (command \"fileopen\") <X1 and X2 - coordinats>, <RADIUS - radius of circle>, <R,G,B - color>\r\n\
\"brect\" -- dawing rectangle in opened file (command \"fileopen\") <X1,Y1 and X2,Y2 - coordinats>, <R,G,B - color>\r\n\
\"brect_filled\" -- dawing rectangle filled in opened file (command \"fileopen\") <X1,Y1 and X2,Y2 - coordinats>, <R,G,B - color>\r\n\
\"btriangle\" -- dawing triangle in opened file (command \"fileopen\") <X1,Y1 and X2,Y2 and X3,Y3 - coordinats>, <R,G,B - color>\r\n\
\r\n\
\==========\r\n"


/***************************************
БИНАРНЫЙ  ФОРМАТ
****************************************/
#define _id_bin                           0x00                            //идентификатор бинарного обращения
//адреса принятого массива
#define _id_in_bin_addr             0x00000000              //1-,байт - идентификатора бинарного обмена
#define _size_in_addr                 0x00000001              //4 байта - размер принимаемого массива
#define _incmd_addr                  0x00000005              //2 байта - команда

#define _incmd_filename            0x00000007              //начало имени файла  

#define _addr_setpixel_X1          0x00000007              //4 байта
#define _addr_setpixel_Y1          0x0000000B              //4 байта
#define _addr_setpixel_R            0x0000000F              //1 байт
#define _addr_setpixel_G            0x00000010              //1 байт
#define _addr_setpixel_B            0x00000011              //1 байт

//==== bline ====
#define _addr_line_X1                                0x00000007              //4 байта
#define _addr_line_Y1                                0x0000000B              //4 байта
#define _addr_line_X2                                0x0000000F              //4 байта
#define _addr_line_Y2                                0x00000013              //4 байта
#define _addr_line_R                                  0x00000017              //1 байт
#define _addr_line_G                                  0x00000018              //1 байт
#define _addr_line_B                                  0x00000019              //1 байт

//адреса передаваемого массива
#define _id_out_bin_addr           0x00000000              //1-,байт - идентификатора бинарного обмена
#define _size_out_addr               0x00000001              //4 байта - размер принимаемого массива 
#define _outcmd_addr                0x00000005              //2 байта - команда
#define _outcmd_stat_addr        0x00000007              //1 - байт - статус выполнения команды

//коды команд
#define _bmp_cmd_nop              0x0000                      //пустая команда

#define _bmp_cmd_openfile       0x0101                      //открыть файл для работы

#define _bmp_cmd_setpixel        0x0201                      //установка пикселя - нарисовать пиксель
#define _bmp_cmd_ssetpixel              18                      //размер пакета команды _bmp_cmd_setpixel

#define _bmp_cmd_line                               0x0301                      //нарисовать линию
#define _bmp_cmd_sline                              26                     //размер пакета команды _bmp_cmd_setpixel

#define _bmp_cmd_line              0x0301                      //нарисовать линию



typedef struct _CLIENT_BMP
{
    char str_ip_addr[128];
    int ip_port;
    int clientfd;
} CLIENT_BMP;

extern CLIENT_BMP client;

extern void RdClient(void);

#endif
