//bmp.h

#ifndef _BMP_H_
#define _BMP_H_

#include <sys/types.h>
#include <stdint.h>
#include <stdio.h>

//#define _version_h      "V 2.0"
#define _BMP_version_h		0x151230        //год:месяц:число

#pragma pack(1)



//В начале стоит заголовок файла (BITMAPFILEHEADER). Он описан следующим образом:
#pragma pack(1)
typedef struct tagBITMAPFILEHEADER {
    uint16_t	bfType;
    uint32_t	bfSize;
    uint16_t	bfReserved1;
    uint16_t	bfReserved2;
    uint32_t	bfOffBits;
} BITMAPFILEHEADER, *PBITMAPFILEHEADER;


//А дальше идет структура BITMAPINFOHEADER, которая объявлена так:
#pragma pack(1)
typedef struct tagBITMAPINFOHEADER {
    uint32_t	biSize;
    uint32_t		biWidth;
    uint32_t		biHeight;
    uint16_t	biPlanes;
    uint16_t	biBitCount;
    uint32_t	biCompression;
    uint32_t	biSizeImage;
    uint64_t	biXPelsPerMeter;
    uint64_t	biYPelsPerMeter;
    uint32_t	biClrUsed;
    uint32_t	biClrImportant;
} BITMAPINFOHEADER, *PBITMAPINFOHEADER;

//позиция версии структуры
#define _bcSize          0x0E

typedef struct tagBITMAPINFOHEADERr {
    uint32_t	biSize;
    uint8_t		data[128];
} BITMAPINFOHEADERr, *PBITMAPINFOHEADERr;

#pragma pack(1)
typedef struct tagRGBQUAD {
    uint8_t	rgbBlue;
    uint8_t	rgbGreen;
    uint8_t	rgbRed;
    uint8_t	rgbReserved;
} RGBQUAD;

#pragma pack(1)
typedef struct _BMP_PAR {
    uint32_t		step_x;
    uint32_t		step_y;
} BMP_PAR;

#define _BMP_DUMP_SIZE_     0x200000
extern uint8_t BMP_DUMP[_BMP_DUMP_SIZE_];
#define _interval_redraw            500000
extern uint8_t BMP_REDRAW_WORK;      //поток перезаписи
extern uint8_t BMP_FILE;;

extern BITMAPFILEHEADER		bhfi;
extern BITMAPINFOHEADER		bhfo;
extern BITMAPINFOHEADERr	bhfor;
/*
***************************************
* функции статуса изображения         *
***************************************
*/
extern int BMP_FileAnalise(char *fname);

/*
*****************************************************
* функции прямого обращения к элементам изображению *
*****************************************************
*/
extern int BMP_SetPixel(uint64_t x, uint64_t y, uint8_t R, uint8_t G, uint8_t B);
extern int BMP_GetPixel(uint64_t x, uint64_t y, uint8_t * R, uint8_t * G, uint8_t * B);

/*
*****************************************************
* функции примитивов  (формирования фигур/элементов)*
*****************************************************
*/
//линия (отрезок) 
extern void BMP_Line(uint32_t x1, uint32_t y1, uint32_t x2, uint32_t y2, uint8_t R, uint8_t G, uint8_t B);
//окружность-круг
extern void BMP_Circle(uint32_t x, uint32_t y, uint32_t radius, uint8_t R, uint8_t G, uint8_t B);
extern void BMP_Circlefill(uint32_t x, uint32_t y, uint32_t radius, uint8_t R, uint8_t G, uint8_t B);
extern void BMP_Circlefill_fuzzy(uint32_t x, uint32_t y, uint32_t radius, uint8_t R, uint8_t G, uint8_t B, int f);
//прямоугольник
extern void BMP_rect(uint32_t x1, uint32_t y1, uint32_t x2, uint32_t y2, uint8_t R, uint8_t G, uint8_t B);
extern void BMP_rect_filled(uint32_t x1, uint32_t y1, uint32_t x2, uint32_t y2, uint8_t R, uint8_t G, uint8_t B);
//треугольник
extern void BMP_triangle(uint32_t x1, uint32_t  y1, uint32_t x2, uint32_t y2, uint32_t x3, uint32_t y3, uint8_t R, uint8_t G, uint8_t B);


/*
****************************************************
* служебные функции                                *
****************************************************
*/
extern  void pthBMP_Redraw(void);


#endif
